package com.example.examentest.Api

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.examentest.Models.Catalog
import com.example.examentest.databinding.ItemNewsBinding

class AdapterCatalog(private val listener: Listener): RecyclerView.Adapter<AdapterCatalog.CatalogHolder>() {
    private val ListCatalog = ArrayList<Catalog>()
    class CatalogHolder(item: View): RecyclerView.ViewHolder(item){
        val binding = ItemNewsBinding.bind(item)
        fun bind(catalog: Catalog, listener: Listener) = with(binding){
            itemCatalogName.text = catalog.name
           itemCatalogDays.text = catalog.timeResul
            itemCatalogPrice.text = catalog.price.toString() + " $"
            ItemsCatalog.setOnClickListener{
                listener.OnClick(catalog)
            }
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): CatalogHolder {
        val view = LayoutInflater.from(parent.context).inflate(com.example.examentest.R.layout.item_news, parent, false)
        return CatalogHolder(view)
    }

    override fun getItemCount(): Int {
        return ListCatalog.size
    }

    override fun onBindViewHolder(holder: CatalogHolder, position: Int) {
        holder.bind(ListCatalog[position], listener)
    }
    fun AddCatalog(catalog: Catalog){
        ListCatalog.add(catalog)
        notifyDataSetChanged()
    }
    interface Listener{
        fun OnClick(catalog: Catalog)
    }
}