package com.example.examentest.Api

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.examentest.Models.News
import com.example.examentest.databinding.ItemCatalogBinding
import com.squareup.picasso.Picasso

class AdapterNews():RecyclerView.Adapter<AdapterNews.NewsHolder>() {
    private val ListNews = ArrayList<News>()
    class NewsHolder(item: View): RecyclerView.ViewHolder(item){
        private val binding = ItemCatalogBinding.bind(item)
        fun bind(news: News) = with(binding){
            newsName.text = news.name
            newsDescription.text = news.description
            newsCost.text = news.price.toString() + " $"
            Picasso.get().load(news.image).into(newsPhoto)
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): NewsHolder {
        val view = LayoutInflater.from(parent.context).inflate(com.example.examentest.R.layout.item_catalog, parent, false)
        return NewsHolder(view)
    }

    override fun getItemCount(): Int {
        return ListNews.size
    }

    override fun onBindViewHolder(holder: NewsHolder, position: Int) {
        holder.bind(ListNews[position])
    }
    fun AddNews(news: News){
        ListNews.add(news)
        notifyDataSetChanged()
    }
}