package com.example.examentest

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.text.Editable
import android.text.TextWatcher
import android.view.GestureDetector
import android.view.MotionEvent
import android.view.View.OnTouchListener
import android.widget.Toast
import com.example.examentest.Api.ApiHttp
import com.example.examentest.databinding.ActivityCodeCheckBinding
import org.w3c.dom.Text
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class CodeCheckActivity : AppCompatActivity(), GestureDetector.OnGestureListener{
    lateinit var binding: ActivityCodeCheckBinding
    lateinit var gestureDetector: GestureDetector
    var code = ""
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityCodeCheckBinding.inflate(layoutInflater)
        setContentView(binding.root)
        gestureDetector = GestureDetector(this, this)
        Listner()
    }

    fun Listner(){
        binding.One.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
if(binding.One.text.toString().length == 1){
    code += s
    binding.Two.requestFocus()
}
            }

            override fun afterTextChanged(s: Editable?) {
            }

        })
        binding.Two.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                if(binding.Two.text.toString().length == 1){
                    code += s
                    binding.Three.requestFocus()
                }
            }

            override fun afterTextChanged(s: Editable?) {
            }

        })
        binding.Three.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                if(binding.Three.text.toString().length == 1){
                    code += s
                    binding.Four.requestFocus()
                }
            }

            override fun afterTextChanged(s: Editable?) {
            }

        })
        binding.Four.addTextChangedListener(object : TextWatcher{
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {
            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                if(binding.Four.text.toString().length == 1){
                    code += s

                }
                if(code.length == 4){
                    CheckCode()
                }
            }

            override fun afterTextChanged(s: Editable?) {
            }

        })
    }

    fun CheckCode(){
        ApiHttp.retrofitApi.CheckCode(ApiHttp.User_mail, code).enqueue(object : Callback<String>{
            override fun onResponse(call: Call<String>, response: Response<String>) {
                if(response.code() == 200){
                    Toast.makeText(this@CodeCheckActivity, "Всё хорошо", Toast.LENGTH_LONG).show()
                }
                else{
                    Toast.makeText(this@CodeCheckActivity, "Всё плохо", Toast.LENGTH_LONG).show()
                    code = ""
                    binding.One.setText("")
                    binding.Two.setText("")
                    binding.Three.setText("")
                    binding.Four.setText("")
                    binding.One.requestFocus()
                    ApiHttp.retrofitApi.SendCode(ApiHttp.User_mail).enqueue(object : Callback<String>{
                        override fun onResponse(call: Call<String>, response: Response<String>) {
                        }

                        override fun onFailure(call: Call<String>, t: Throwable) {
                            Toast.makeText(this@CodeCheckActivity, t.message, Toast.LENGTH_SHORT).show()
                        }

                    })
                }
            }

            override fun onFailure(call: Call<String>, t: Throwable) {
                Toast.makeText(this@CodeCheckActivity, t.message, Toast.LENGTH_SHORT).show()
            }

        })
    }

    override fun onDown(e: MotionEvent): Boolean {
        return false
    }

    override fun onShowPress(e: MotionEvent) {

    }

    override fun onSingleTapUp(e: MotionEvent): Boolean {
        return false
    }

    override fun onScroll(
        e1: MotionEvent?,
        e2: MotionEvent,
        distanceX: Float,
        distanceY: Float
    ): Boolean {
        return false
    }

    override fun onLongPress(e: MotionEvent) {

    }

    override fun onTouchEvent(event: MotionEvent?): Boolean {
        return if(gestureDetector.onTouchEvent(event!!)){
            true
        }
        else{
            return super.onTouchEvent(event)
        }

    }

    override fun onFling(
        e1: MotionEvent?,
        e2: MotionEvent,
        velocityX: Float,
        velocityY: Float
    ): Boolean {
        val diffY = e2.y - e1!!.y
        val diffX = e2.x - e1.x
        if(Math.abs(diffX) > Math.abs(diffY)){
            if(Math.abs(diffX)>100 && Math.abs(velocityX)>100)
            {
                if(diffX<0){
                    startActivity(Intent(this@CodeCheckActivity, MainActivity2::class.java))
                }
            }
        }
        return true
    }

}