package com.example.examentest

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.os.CountDownTimer
import android.widget.Toast
import androidx.recyclerview.widget.LinearLayoutManager
import com.example.examentest.Api.AdapterCatalog
import com.example.examentest.Api.AdapterNews
import com.example.examentest.Api.ApiHttp
import com.example.examentest.Models.Catalog
import com.example.examentest.Models.News
import com.example.examentest.databinding.ActivityMainBinding
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class MainActivity : AppCompatActivity(), AdapterCatalog.Listener {
    lateinit var binding: ActivityMainBinding
    lateinit var timer: CountDownTimer
private val adapterNews = AdapterNews()
    private val adapterCatalog = AdapterCatalog(this)
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityMainBinding.inflate(layoutInflater)
        setContentView(binding.root)
        Timer()
GetData()
    }

 fun Timer(){
     timer = object : CountDownTimer(1000, 1000){
         override fun onTick(millisUntilFinished: Long) {
         }

         override fun onFinish() {
             startActivity(Intent(this@MainActivity, CodeCheckActivity::class.java))
         }
     }
     timer.start()
 }


fun GetNews(){
    ApiHttp.retrofitApi.GetNews().enqueue(object : Callback<ArrayList<News>>{
        override fun onResponse(call: Call<ArrayList<News>>, response: Response<ArrayList<News>>) {
            if(response.code()==200){
                val data = response.body()
                InitListNews(data!!)
            }
        }

        override fun onFailure(call: Call<ArrayList<News>>, t: Throwable) {
            Toast.makeText(this@MainActivity, t.message, Toast.LENGTH_LONG).show()
        }

    })
}

fun InitListNews(data: ArrayList<News>){
    with(binding){
        ItemsNews.adapter = adapterNews
        ItemsNews.layoutManager = LinearLayoutManager(this@MainActivity, LinearLayoutManager.HORIZONTAL, false)
        val listNews = data
        for(element in listNews){
            adapterNews.AddNews(element)
        }
    }
}
    fun GetCatalog(){
        ApiHttp.retrofitApi.GetCatalog().enqueue(object : Callback<ArrayList<Catalog>>{
            override fun onResponse(
                call: Call<ArrayList<Catalog>>,
                response: Response<ArrayList<Catalog>>
            ) {
                if(response.code()==200){
                    val data = response.body()
                    InitListCatalog(data!!)
                }
            }

            override fun onFailure(call: Call<ArrayList<Catalog>>, t: Throwable) {
                Toast.makeText(this@MainActivity, t.message, Toast.LENGTH_LONG).show()
            }

        })
    }

    fun InitListCatalog(data: ArrayList<Catalog>){
        with(binding){
            ItemsCatalog.adapter = adapterCatalog
            ItemsCatalog.layoutManager = LinearLayoutManager(this@MainActivity, LinearLayoutManager.VERTICAL, false)
            val ListCat = data
            for(element in ListCat){
                adapterCatalog.AddCatalog(element)
            }
        }
    }
    fun GetData(){
GetNews()
        GetCatalog()
    }

    override fun OnClick(catalog: Catalog) {
       val itemcataloginformationListDialogFragment = ItemcataloginformationListDialogFragment()
        val bundle = Bundle()
        bundle.putSerializable("iteminformation", catalog)
        itemcataloginformationListDialogFragment.arguments = bundle
        itemcataloginformationListDialogFragment.show(supportFragmentManager, "pop")
    }


}